--- //depot/vendor/freebsd/src/sys/net/if_spppsubr.c	2004/07/15 08:30:31
+++ //depot/user/rwatson/netperf/sys/net/if_spppsubr.c	2004/07/15 22:19:17
@@ -92,12 +92,8 @@
 #include <net/if_sppp.h>
 
 #if defined(__FreeBSD__) && __FreeBSD__ >= 3
-# define UNTIMEOUT(fun, arg, handle) untimeout(fun, arg, handle)
-# define TIMEOUT(fun, arg1, arg2, handle) handle = timeout(fun, arg1, arg2)
 # define IOCTL_CMD_T	u_long
 #else
-# define UNTIMEOUT(fun, arg, handle) untimeout(fun, arg)
-# define TIMEOUT(fun, arg1, arg2, handle) timeout(fun, arg1, arg2)
 # define IOCTL_CMD_T	int
 #endif
 
@@ -259,10 +255,11 @@
 	void	(*scr)(struct sppp *sp);
 };
 
+struct mtx sppp_mtx;
+MTX_SYSINIT(sppp_mtx, &sppp_mtx, "sppp_mtx", MTX_DEF);
+
 static struct sppp *spppq;
-#if defined(__FreeBSD__) && __FreeBSD__ >= 3
-static struct callout_handle keepalive_ch;
-#endif
+static struct callout keepalive_callout;
 
 #if defined(__FreeBSD__) && __FreeBSD__ >= 3 && __FreeBSD_version < 501113
 #define	SPP_FMT		"%s%d: "
@@ -964,13 +961,18 @@
 {
 	struct sppp *sp = (struct sppp*) ifp;
 
+	mtx_lock(&sppp_mtx);
 	/* Initialize keepalive handler. */
-	if (spppq == NULL)
-		TIMEOUT(sppp_keepalive, 0, hz * 10, keepalive_ch);
+	if (spppq == NULL) {
+		callout_init(&keepalive_callout, 0);
+		callout_reset(&keepalive_callout, hz * 10, sppp_keepalive,
+		    NULL); 
+	}
 
 	/* Insert new entry into the keepalive list. */
 	sp->pp_next = spppq;
 	spppq = sp;
+	mtx_unlock(&sppp_mtx);
 
 	sp->pp_if.if_mtu = PP_MTU;
 	sp->pp_if.if_flags = IFF_POINTOPOINT | IFF_MULTICAST;
@@ -1016,6 +1018,7 @@
 	struct sppp **q, *p, *sp = (struct sppp*) ifp;
 	int i;
 
+	mtx_lock(&sppp_mtx);
 	/* Remove the entry from the keepalive list. */
 	for (q = &spppq; (p = *q); q = &p->pp_next)
 		if (p == sp) {
@@ -1025,11 +1028,12 @@
 
 	/* Stop keepalive handler. */
 	if (spppq == NULL)
-		UNTIMEOUT(sppp_keepalive, 0, keepalive_ch);
+		callout_stop(&keepalive_callout);
+	mtx_unlock(&sppp_mtx);
 
 	for (i = 0; i < IDX_COUNT; i++)
-		UNTIMEOUT((cps[i])->TO, (void *)sp, sp->ch[i]);
-	UNTIMEOUT(sppp_pap_my_TO, (void *)sp, sp->pap_my_to_ch);
+		untimeout((cps[i])->TO, (void *)sp, sp->ch[i]);
+	untimeout(sppp_pap_my_TO, (void *)sp, sp->pap_my_to_ch);
 	mtx_destroy(&sp->pp_cpq.ifq_mtx);
 	mtx_destroy(&sp->pp_fastq.ifq_mtx);
 }
@@ -2008,8 +2012,8 @@
 		case STATE_STOPPING:
 			sppp_cp_send(sp, cp->proto, TERM_REQ,
 				     ++sp->pp_seq[cp->protoidx], 0, 0);
-			TIMEOUT(cp->TO, (void *)sp, sp->lcp.timeout,
-			    sp->ch[cp->protoidx]);
+			sp->ch[cp->protoidx] = timeout(cp->TO, (void *)sp,
+			    sp->lcp.timeout);
 			break;
 		case STATE_REQ_SENT:
 		case STATE_ACK_RCVD:
@@ -2019,8 +2023,8 @@
 			break;
 		case STATE_ACK_SENT:
 			(cp->scr)(sp);
-			TIMEOUT(cp->TO, (void *)sp, sp->lcp.timeout,
-			    sp->ch[cp->protoidx]);
+			sp->ch[cp->protoidx] = timeout(cp->TO, (void *)sp,
+			    sp->lcp.timeout);
 			break;
 		}
 
@@ -2036,7 +2040,7 @@
 {
 	sp->state[cp->protoidx] = newstate;
 
-	UNTIMEOUT(cp->TO, (void *)sp, sp->ch[cp->protoidx]);
+	untimeout(cp->TO, (void *)sp, sp->ch[cp->protoidx]);
 	switch (newstate) {
 	case STATE_INITIAL:
 	case STATE_STARTING:
@@ -2049,8 +2053,8 @@
 	case STATE_REQ_SENT:
 	case STATE_ACK_RCVD:
 	case STATE_ACK_SENT:
-		TIMEOUT(cp->TO, (void *)sp, sp->lcp.timeout,
-		    sp->ch[cp->protoidx]);
+		sp->ch[cp->protoidx] = timeout(cp->TO, (void *)sp,
+		    sp->lcp.timeout);
 		break;
 	}
 }
@@ -4147,7 +4151,7 @@
 		 * a number between 300 and 810 seconds.
 		 */
 		i = 300 + ((unsigned)(random() & 0xff00) >> 7);
-		TIMEOUT(chap.TO, (void *)sp, i * hz, sp->ch[IDX_CHAP]);
+		sp->ch[IDX_CHAP] = timeout(chap.TO, (void *)sp, i * hz);
 	}
 
 	if (debug) {
@@ -4191,7 +4195,7 @@
 
 	if (debug)
 		log(LOG_DEBUG, SPP_FMT "chap tld\n", SPP_ARGS(ifp));
-	UNTIMEOUT(chap.TO, (void *)sp, sp->ch[IDX_CHAP]);
+	untimeout(chap.TO, (void *)sp, sp->ch[IDX_CHAP]);
 	sp->lcp.protos &= ~(1 << IDX_CHAP);
 
 	lcp.Close(sp);
@@ -4327,7 +4331,7 @@
 
 	/* ack and nak are his authproto */
 	case PAP_ACK:
-		UNTIMEOUT(sppp_pap_my_TO, (void *)sp, sp->pap_my_to_ch);
+		untimeout(sppp_pap_my_TO, (void *)sp, sp->pap_my_to_ch);
 		if (debug) {
 			log(LOG_DEBUG, SPP_FMT "pap success",
 			    SPP_ARGS(ifp));
@@ -4356,7 +4360,7 @@
 		break;
 
 	case PAP_NAK:
-		UNTIMEOUT(sppp_pap_my_TO, (void *)sp, sp->pap_my_to_ch);
+		untimeout(sppp_pap_my_TO, (void *)sp, sp->pap_my_to_ch);
 		if (debug) {
 			log(LOG_INFO, SPP_FMT "pap failure",
 			    SPP_ARGS(ifp));
@@ -4413,8 +4417,8 @@
 	if (sp->myauth.proto == PPP_PAP) {
 		/* we are peer, send a request, and start a timer */
 		pap.scr(sp);
-		TIMEOUT(sppp_pap_my_TO, (void *)sp, sp->lcp.timeout,
-		    sp->pap_my_to_ch);
+		sp->pap_my_to_ch = timeout(sppp_pap_my_TO, (void *)sp,
+		    sp->lcp.timeout);
 	}
 }
 
@@ -4517,8 +4521,8 @@
 
 	if (debug)
 		log(LOG_DEBUG, SPP_FMT "pap tld\n", SPP_ARGS(ifp));
-	UNTIMEOUT(pap.TO, (void *)sp, sp->ch[IDX_PAP]);
-	UNTIMEOUT(sppp_pap_my_TO, (void *)sp, sp->pap_my_to_ch);
+	untimeout(pap.TO, (void *)sp, sp->ch[IDX_PAP]);
+	untimeout(sppp_pap_my_TO, (void *)sp, sp->pap_my_to_ch);
 	sp->lcp.protos &= ~(1 << IDX_PAP);
 
 	lcp.Close(sp);
@@ -4645,7 +4649,12 @@
 	struct sppp *sp;
 	int s;
 
+	/*
+	 * XXXRW: It would be nice to avoid calling all this stuff while
+	 * holding sppp_mtx, or we risk lock order reversals.
+	 */
 	s = splimp();
+	mtx_lock(&sppp_mtx);
 	for (sp=spppq; sp; sp=sp->pp_next) {
 		struct ifnet *ifp = &sp->pp_if;
 
@@ -4684,8 +4693,9 @@
 				sp->lcp.echoid, 4, &nmagic);
 		}
 	}
+	callout_reset(&keepalive_callout, hz * 10, sppp_keepalive, NULL);
+	mtx_unlock(&sppp_mtx);
 	splx(s);
-	TIMEOUT(sppp_keepalive, 0, hz * 10, keepalive_ch);
 }
 
 /*
--- //depot/vendor/freebsd/src/sys/net/if_stf.c	2004/07/15 08:30:31
+++ //depot/user/rwatson/netperf/sys/net/if_stf.c	2004/07/15 22:19:17
@@ -139,13 +139,11 @@
 #define sc_ro	__sc_ro46.__sc_ro4
 	const struct encaptab *encap_cookie;
 	LIST_ENTRY(stf_softc) sc_list;	/* all stf's are linked */
+	struct mtx	sc_mtx;		/* protect sc_ro */
 };
 
 /*
  * All mutable global variables in if_stf.c are protected by stf_mtx.
- * XXXRW: Note that mutable fields in the softc are not currently locked:
- * in particular, sc_ro needs to be protected from concurrent entrance
- * of stf_output().
  */
 static struct mtx stf_mtx;
 static LIST_HEAD(, stf_softc) stf_softc_list;
@@ -231,6 +229,7 @@
 		ifc_free_unit(ifc, unit);
 		return (ENOMEM);
 	}
+	mtx_init(&sc->sc_mtx, "stf sc_mtx", NULL, MTX_DEF);
 
 	ifp->if_mtu    = IPV6_MMTU;
 	ifp->if_ioctl  = stf_ioctl;
@@ -255,6 +254,7 @@
 	bpfdetach(&sc->sc_if);
 	if_detach(&sc->sc_if);
 
+	mtx_destroy(&sc->sc_mtx);
 	free(sc, M_STF);
 }
 
@@ -430,9 +430,10 @@
 	struct ip *ip;
 	struct ip6_hdr *ip6;
 	struct in6_ifaddr *ia6;
-#ifdef MAC
+	struct route ro;
 	int error;
 
+#ifdef MAC
 	error = mac_check_ifnet_transmit(ifp, m);
 	if (error) {
 		m_freem(m);
@@ -534,9 +535,7 @@
 	else
 		ip_ecn_ingress(ECN_NOCARE, &ip->ip_tos, &tos);
 
-	/*
-	 * XXXRW: Locking of sc_ro required.
-	 */
+	mtx_lock(&sc->sc_mtx);
 	dst4 = (struct sockaddr_in *)&sc->sc_ro.ro_dst;
 	if (dst4->sin_family != AF_INET ||
 	    bcmp(&dst4->sin_addr, &ip->ip_dst, sizeof(ip->ip_dst)) != 0) {
@@ -555,12 +554,21 @@
 		if (sc->sc_ro.ro_rt == NULL) {
 			m_freem(m);
 			ifp->if_oerrors++;
+			mtx_unlock(&sc->sc_mtx);
 			return ENETUNREACH;
 		}
 	}
 
+	/*
+	 * XXXRW: Holding mutex over call to ip_output(): potential lock
+	 * order issue?  Hard to resolve cleanly with the current route
+	 * caching model, as we have to synchronize access to shared softc
+	 * state.
+	 */
 	ifp->if_opackets++;
-	return ip_output(m, NULL, &sc->sc_ro, 0, NULL, NULL);
+	error = ip_output(m, NULL, &ro, 0, NULL, NULL);
+	mtx_unlock(&sc->sc_mtx);
+	return (error);
 }
 
 static int
--- //depot/vendor/freebsd/src/sys/net/if_tap.c	2004/08/11 00:15:37
+++ //depot/user/rwatson/netperf/sys/net/if_tap.c	2004/08/11 02:33:29
@@ -113,6 +113,10 @@
  * All global variables in if_tap.c are locked with tapmtx, with the
  * exception of tapdebug, which is accessed unlocked; tapclones is
  * static at runtime.
+ *
+ * XXXRW: si_flags appears not to be protected from concurrent access,
+ * and is written at run-time.
+ * XXXRW: si_drv1 is also used for test-and-set, and isn't synchronized.
  */
 static struct mtx		tapmtx;
 static int			tapdebug = 0;        /* debug flag   */
@@ -162,6 +166,7 @@
 		 * The EBUSY algorithm here can't quite atomically
 		 * guarantee that this is race-free since we have to
 		 * release the tap mtx to deregister the clone handler.
+		 * XXXRW: is this true?
 		 */
 		mtx_lock(&tapmtx);
 		SLIST_FOREACH(tp, &taphead, tap_next) {
@@ -699,6 +704,7 @@
 
 		case SIOCSIFADDR:	/* set MAC address of the remote side */
 			mtx_lock(&tp->tap_mtx);
+			/* XXXRW: Does this actually do anything? */
 			bcopy(data, tp->ether_addr, sizeof(tp->ether_addr));
 			mtx_unlock(&tp->tap_mtx);
 			break;
@@ -753,6 +759,7 @@
 			if (flag & IO_NDELAY)
 				return (EWOULDBLOCK);
 
+			/* This looks like a wanna-be condition variable. */
 			mtx_lock(&tp->tap_mtx);
 			tp->tap_flags |= TAP_RWAIT;
 			mtx_unlock(&tp->tap_mtx);
--- //depot/vendor/freebsd/src/sys/net/if_tun.c	2004/07/15 08:30:31
+++ //depot/user/rwatson/netperf/sys/net/if_tun.c	2004/07/15 22:19:17
@@ -59,6 +59,12 @@
  * tun_list is protected by global tunmtx.  Other mutable fields are
  * protected by tun->tun_mtx, or by their owning subsystem.  tun_dev is
  * static for the duration of a tunnel interface.
+ *
+ * XXXRW: we allocate si_drv1 for the dev_t on demand, rather than when
+ * the dev_t is instantiated.  Nothing serializes the test/set of that
+ * field.
+ *
+ * XXXRW: what serializes access to si_flags?
  */
 struct tun_softc {
 	TAILQ_ENTRY(tun_softc)	tun_list;
@@ -121,6 +127,9 @@
 static d_ioctl_t	tunioctl;
 static d_poll_t		tunpoll;
 
+/*
+ * XXXRW: can remove D_NEEDGIANT?  Probably not because of si_drv1 for now.
+ */
 static struct cdevsw tun_cdevsw = {
 	.d_version =	D_VERSION,
 	.d_flags =	D_PSEUDO | D_NEEDGIANT,
@@ -382,6 +391,9 @@
 	ifp->if_flags |= IFF_UP | IFF_RUNNING;
 	getmicrotime(&ifp->if_lastchange);
 
+	/*
+	 * XXXRW: interface locking.
+	 */
 	for (ifa = TAILQ_FIRST(&ifp->if_addrhead); ifa;
 	     ifa = TAILQ_NEXT(ifa, ifa_link)) {
 		if (ifa->ifa_addr == NULL)
--- //depot/vendor/freebsd/src/sys/net/raw_cb.c	2004/06/15 04:15:33
+++ //depot/user/rwatson/netperf/sys/net/raw_cb.c	2004/06/18 00:24:39
@@ -123,6 +123,7 @@
 		m_freem(dtom(rp->rcb_faddr));
 	rp->rcb_faddr = 0;
 #endif
+	/* Unlocked read. */
 	if (rp->rcb_socket->so_state & SS_NOFDREF)
 		raw_detach(rp);
 }
--- //depot/vendor/freebsd/src/sys/net/raw_usrreq.c	2004/06/15 04:15:33
+++ //depot/user/rwatson/netperf/sys/net/raw_usrreq.c	2004/06/18 00:24:39
@@ -76,6 +76,10 @@
 	register struct mbuf *m = m0;
 	struct socket *last;
 
+	/*
+	 * XXXRW: Potential lock order issues due to holding the
+	 * rawcb_mtx across all this stuff.  Need to revisit.
+	 */
 	last = 0;
 	mtx_lock(&rawcb_mtx);
 	LIST_FOREACH(rp, &rawcb_list, list) {
--- //depot/vendor/freebsd/src/sys/net/rtsock.c	2004/08/13 22:25:30
+++ //depot/user/rwatson/netperf/sys/net/rtsock.c	2004/08/14 16:02:22
@@ -54,10 +54,18 @@
 MALLOC_DEFINE(M_RTABLE, "routetbl", "routing tables");
 
 /* NB: these are not modified */
+/*
+ * XXXRW: It would be really nice to add const to these, but that may
+ * not be possible due to where they are passed in.  We might need
+ * to const-poison a whole boatload of APIs...?
+ */
 static struct	sockaddr route_dst = { 2, PF_ROUTE, };
 static struct	sockaddr route_src = { 2, PF_ROUTE, };
 static struct	sockaddr sa_zero   = { sizeof(sa_zero), AF_INET, };
 
+/*
+ * XXXRW: These fields are locked by RTSOCK_LOCK().
+ */
 static struct {
 	int	ip_count;	/* attacked w/ AF_INET */
 	int	ip6_count;	/* attached w/ AF_INET6 */
--- //depot/vendor/freebsd/src/sys/netatalk/aarp.c	2004/08/10 03:25:35
+++ //depot/user/rwatson/netperf/sys/netatalk/aarp.c	2004/08/11 02:33:29
@@ -109,10 +109,6 @@
 #define AARPT_KILLC	20
 #define AARPT_KILLI	3
 
-# if !defined(__FreeBSD__)
-extern u_char			etherbroadcastaddr[6];
-# endif /* __FreeBSD__ */
-
 static const u_char atmulticastaddr[ 6 ] = {
     0x09, 0x00, 0x07, 0xff, 0xff, 0xff,
 };
@@ -124,6 +120,9 @@
     0x00, 0x00, 0x00,
 };
 
+/*
+ * XXXRW: Make use callouts, not timeouts.
+ */
 static struct callout_handle aarptimer_ch =
     CALLOUT_HANDLE_INITIALIZER(&aarptimer_ch);
 
@@ -158,6 +157,7 @@
     struct at_ifaddr	*aa;
     struct sockaddr_at	*sat2;
 
+	AT_IFADDR_LIST_LOCK();
 	for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 		sat2 = &(aa->aa_addr);
 		if (sat2->sat_addr.s_net == sat->sat_addr.s_net) {
@@ -169,6 +169,8 @@
 			break;
 		}
 	}
+	IFAREF((struct ifaddr *)aa);
+	AT_IFADDR_LIST_UNLOCK();
 	return (aa);
 }
 
@@ -251,6 +253,7 @@
 	   ntohs(AA_SAT(aa)->sat_addr.s_net),
 	   AA_SAT(aa)->sat_addr.s_node);
 #endif /* NETATALKDEBUG */
+    IFAFREE((struct ifaddr *)aa);
 
     sa.sa_len = sizeof(struct sockaddr);
     sa.sa_family = AF_UNSPEC;
@@ -279,6 +282,7 @@
 	    bcopy(ifp->if_broadcastaddr, (caddr_t)desten,
 		    sizeof(ifp->if_addrlen));
 	}
+	IFAFREE((struct ifaddr *)aa);
 	return (1);
     }
 
@@ -388,6 +392,8 @@
 	/*
 	 * Since we don't know the net, we just look for the first
 	 * phase 1 address on the interface.
+	 *
+	 * XXXRW: Note, if_addrhead not locked here.
 	 */
 	for (aa = (struct at_ifaddr *)TAILQ_FIRST(&ifp->if_addrhead); aa;
 		aa = (struct at_ifaddr *)aa->aa_ifa.ifa_link.tqe_next) {
@@ -421,6 +427,7 @@
 	    untimeout(aarpprobe, ifp, aa->aa_ch);
 	    wakeup(aa);
 	    m_freem(m);
+	    IFAFREE((struct ifaddr *)aa);
 	    return;
 	} else if (op != AARPOP_PROBE) {
 	    /*
@@ -433,6 +440,7 @@
 		    ea->aarp_sha[ 0 ], ea->aarp_sha[ 1 ], ea->aarp_sha[ 2 ],
 		    ea->aarp_sha[ 3 ], ea->aarp_sha[ 4 ], ea->aarp_sha[ 5 ]);
 	    m_freem(m);
+	    IFAFREE((struct ifaddr *)aa);
 	    return;
 	}
     }
@@ -449,6 +457,7 @@
 	    aarptfree(aat);
 	    AARPTAB_UNLOCK();
 	    m_freem(m);
+	    IFAFREE((struct ifaddr *)aa);
 	    return;
 	}
 
@@ -484,6 +493,7 @@
     if (tpa.s_net != ma.s_net || tpa.s_node != ma.s_node ||
 	    op == AARPOP_RESPONSE || (aa->aa_flags & AFA_PROBING)) {
 	m_freem(m);
+	IFAFREE((struct ifaddr *)aa);
 	return;
     }
 
@@ -502,6 +512,7 @@
 		sizeof(struct ether_aarp));
 	M_PREPEND(m, sizeof(struct llc), M_DONTWAIT);
 	if (m == NULL) {
+	    IFAFREE((struct ifaddr *)aa);
 	    return;
 	}
 	llc = mtod(m, struct llc *);
@@ -515,6 +526,7 @@
     } else {
 	eh->ether_type = htons(ETHERTYPE_AARP);
     }
+    IFAFREE((struct ifaddr *)aa);
 
     ea->aarp_tpnode = ea->aarp_spnode;
     ea->aarp_spnode = ma.s_node;
@@ -680,6 +692,9 @@
     struct aarptab	*aat;
     int			i;
 
+    /*
+     * XXXRW: Should grab mutex before untimeout?
+     */
     untimeout(aarptimer, 0, aarptimer_ch);
     AARPTAB_LOCK();
     for (i = 0, aat = aarptab; i < AARPTAB_SIZE; i++, aat++) {
--- //depot/vendor/freebsd/src/sys/netatalk/at_control.c	2004/07/19 17:20:31
+++ //depot/user/rwatson/netperf/sys/netatalk/at_control.c	2004/07/20 01:38:51
@@ -21,7 +21,15 @@
 #include <netatalk/at_var.h>
 #include <netatalk/at_extern.h>
 
+/*
+ * Access to at_ifaddr_list and the aa_next pointer in struct at_ifaddr are
+ * locked with this global mutex.
+ *
+ * XXXRW: We'll need something better in the future.
+ */
+struct mtx at_ifaddr_mtx;
 struct at_ifaddr *at_ifaddr_list;
+MTX_SYSINIT(at_ifaddr_mtx, &at_ifaddr_mtx, "at_ifaddr_mtx", MTX_DEF);
 
 static int aa_dorangeroute(struct ifaddr *ifa, u_int first, u_int last,
 	    int cmd);
@@ -53,10 +61,12 @@
 	struct at_ifaddr *aa0;
 	struct at_ifaddr *aa = NULL;
 	struct ifaddr *ifa, *ifa0;
+	int error;
 
 	/*
 	 * If we have an ifp, then find the matching at_ifaddr if it exists
 	 */
+	mtx_lock(&at_ifaddr_mtx);
 	if (ifp != NULL) {
 		for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 			if (aa->aa_ifp == ifp)
@@ -90,16 +100,20 @@
 		 * If we a retrying to delete an addres but didn't find such,
 		 * then rewurn with an error
 		 */
-		if (cmd == SIOCDIFADDR && aa == NULL)
+		if (cmd == SIOCDIFADDR && aa == NULL) {
+			mtx_unlock(&at_ifaddr_mtx);
 			return (EADDRNOTAVAIL);
+		}
 		/*FALLTHROUGH*/
 
 	case SIOCSIFADDR:
 		/* 
 		 * If we are not superuser, then we don't get to do these ops.
 		 */
-		if (suser(td))
+		if (suser(td)) {
+			mtx_unlock(&at_ifaddr_mtx);
 			return (EPERM);
+		}
 
 		sat = satosat(&ifr->ifr_addr);
 		nr = (struct netrange *)sat->sat_zero;
@@ -127,8 +141,7 @@
 			}
 		}
 
-		if (ifp == NULL)
-			panic("at_control");
+		KASSERT(ifp != NULL, ("at_control: ifp == NULL"));
 
 		/*
 		 * If we failed to find an existing at_ifaddr entry, then we 
@@ -193,6 +206,9 @@
 			/*
 			 * If we DID find one then we clobber any routes
 			 * dependent on it..
+			 *
+			 * XXXRW: Do we really want to hold at_ifaddr_mtx
+			 * over at_scrub()?
 			 */
 			at_scrub(ifp, aa);
 		}
@@ -222,8 +238,10 @@
 			}
 		}
 
-		if (aa == NULL)
+		if (aa == NULL) {
+			mtx_unlock(&at_ifaddr_mtx);
 			return (EADDRNOTAVAIL);
+		}
 		break;
 	}
 
@@ -231,6 +249,7 @@
 	 * By the time this switch is run we should be able to assume that
 	 * the "aa" pointer is valid when needed.
 	 */
+	error = 0;
 	switch (cmd) {
 	case SIOCGIFADDR:
 
@@ -252,18 +271,30 @@
 		break;
 
 	case SIOCSIFADDR:
-		return (at_ifinit(ifp, aa,
-		    (struct sockaddr_at *)&ifr->ifr_addr));
+		/*
+		 * XXXRW: Do we really want to hold at_ifaddr_mtx over
+		 * at_ifinit().
+		 */
+		error = at_ifinit(ifp, aa,
+		    (struct sockaddr_at *)&ifr->ifr_addr);
+		break;
 
 	case SIOCAIFADDR:
 		if (sateqaddr(&ifra->ifra_addr, &aa->aa_addr))
-			return (0);
-		return (at_ifinit(ifp, aa,
-		    (struct sockaddr_at *)&ifr->ifr_addr));
+			break;
+		/*
+		 * XXXRW: Do we really want to hold at_ifaddr_mtx over
+		 * at_ifinit().
+		 */
+		error = at_ifinit(ifp, aa,
+		    (struct sockaddr_at *)&ifr->ifr_addr);
+		break;
 
 	case SIOCDIFADDR:
 		/*
 		 * scrub all routes.. didn't we just DO this? XXX yes, del it
+		 *
+		 * XXXRW: Do we want to hold at_ifaddr_mtx over at_scrub()?
 		 */
 		at_scrub(ifp, aa);
 
@@ -287,10 +318,9 @@
 			/*
 			 * if we found it, remove it, otherwise we screwed up.
 			 */
-			if (aa->aa_next)
-				aa->aa_next = aa0->aa_next;
-			else
-				panic("at_control");
+			KASSERT(aa->aa_next != NULL,
+			    ("at_control: aa->aa_next == NULL"));
+			aa->aa_next = aa0->aa_next;
 		}
 
 		/*
@@ -300,11 +330,14 @@
 		break;
 
 	default:
-		if (ifp == NULL || ifp->if_ioctl == NULL)
-			return (EOPNOTSUPP);
-		return ((*ifp->if_ioctl)(ifp, cmd, data));
+		if (ifp == NULL || ifp->if_ioctl == NULL) {
+			error = EOPNOTSUPP;
+			break;
+		}
+		error = (*ifp->if_ioctl)(ifp, cmd, data);
 	}
-	return (0);
+	mtx_unlock(&at_ifaddr_mtx);
+	return (error);
 }
 
 /* 
@@ -318,6 +351,14 @@
 {
 	int error;
 
+	/*
+	 * XXXRW: We don't asser the at_ifaddr_mtx here, but we do rely on
+	 * the caller holding a reference to 'aa' in such a way that it won't
+	 * go away as at_scrub() runs.  In practice this means that either
+	 * the caller has to hold an ifaddr reference or at_ifaddr_mtx.
+	 *
+	 * mtx_assert(&at_ifaddr_mtx, MA_OWNED);
+	 */
 	if (aa->aa_flags & AFA_ROUTE) {
 		if (ifp->if_flags & IFF_LOOPBACK) {
 			if ((error = aa_delsingleroute(&aa->aa_ifa,
@@ -352,6 +393,7 @@
 	int netinc, nodeinc, nnets;
 	u_short net;
 
+	mtx_assert(&at_ifaddr_mtx, MA_OWNED);
 	/* 
 	 * save the old addresses in the at_ifaddr just in case we need them.
 	 */
@@ -495,11 +537,15 @@
 				/*
 				 * start off the probes as an asynchronous
 				 * activity.  though why wait 200mSec?
+				 *
+				 * XXXRW: This probably opens up a race, but
+				 * the race already existed it and so I
+				 * haven't fixed it.
 				 */
 				aa->aa_ch = timeout(aarpprobe, (caddr_t)ifp,
 				    hz / 5);
-				if (tsleep(aa, PPAUSE|PCATCH, "at_ifinit",
-				    0)) {
+				if (msleep(aa, &at_ifaddr_mtx, PPAUSE|PCATCH,
+				    "at_ifinit", 0)) {
 					/*
 					 * theoretically we shouldn't time
 					 * out here so if we returned with an
@@ -547,6 +593,9 @@
 	/* 
 	 * Now that we have selected an address, we need to tell the interface
 	 * about it, just in case it needs to adjust something.
+	 *
+	 * XXXRW: Should we release at_ifaddr_mtx before calling into the
+	 * interface ioctl() code?
 	 */
 	if (ifp->if_ioctl != NULL &&
 	    (error = (*ifp->if_ioctl)(ifp, SIOCSIFADDR, (caddr_t)aa))) {
@@ -619,6 +668,10 @@
 	 * getting risky by now XXX
 	 */
 	if (error) {
+		/*
+		 * XXXRW: Do we want to hold at_ifaddr_mtx over calls to
+		 * at_scrub()?
+		 */
 		at_scrub(ifp, aa);
 		aa->aa_addr = oldaddr;
 		aa->aa_firstnet = onr.nr_firstnet;
@@ -641,6 +694,7 @@
 at_broadcast(struct sockaddr_at *sat)
 {
 	struct at_ifaddr *aa;
+	int ret;
 
 	/*
 	 * If the node is not right, it can't be a broadcast 
@@ -657,13 +711,18 @@
 	/*
 	 * failing that, if the net is one we have, it's a broadcast as well.
 	 */
+	ret = 0;
+	mtx_lock(&at_ifaddr_mtx);
 	for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 		if ((aa->aa_ifp->if_flags & IFF_BROADCAST)
 		    && (ntohs(sat->sat_addr.s_net) >= ntohs(aa->aa_firstnet)
-		    && ntohs(sat->sat_addr.s_net) <= ntohs(aa->aa_lastnet)))
-			return (1);
+		    && ntohs(sat->sat_addr.s_net) <= ntohs(aa->aa_lastnet))) {
+			ret = 1;
+			break;
+		}
 	}
-	return (0);
+	mtx_unlock(&at_ifaddr_mtx);
+	return (ret);
 }
 
 /*
@@ -785,6 +844,10 @@
 	struct ifaddr *ifa;
 	struct ifnet *ifp;
 
+	/*
+	 * XXXRW: #if 0, and hence untested.
+	 */
+	mtx_lock(&at_ifaddr_mtx);
 	while ((aa = at_ifaddr_list) != NULL) {
 		ifp = aa->aa_ifp;
 		at_scrub(ifp, aa);
@@ -795,13 +858,12 @@
 			while (ifa->ifa_next &&
 			    (ifa->ifa_next != (struct ifaddr *)aa))
 				ifa = ifa->ifa_next;
-			if (ifa->ifa_next)
-				ifa->ifa_next =
-				    ((struct ifaddr *)aa)->ifa_next;
-			else
-				panic("at_entry");
+			KASSERT(ifa->ifa_next != NULL,
+			    ("aa_clean: ifa_next == NULL"));
+			ifa->ifa_next = ((struct ifaddr *)aa)->ifa_next;
 		}
 	}
+	mtx_unlock(&at_ifaddr_mtx);
 }
 
 #endif
--- //depot/vendor/freebsd/src/sys/netatalk/at_rmx.c	2004/07/12 18:40:50
+++ //depot/user/rwatson/netperf/sys/netatalk/at_rmx.c	2004/07/12 19:43:55
@@ -40,6 +40,19 @@
 
 int at_inithead(void **head, int off);
 
+/*
+ * XXXRW: hexdump was a static global variable, but I moved it into the
+ * stack rather than stick a mutex around it.  256 bytes is smaller than
+ * it used to be, but this still might be a problem.  Needs to be
+ * revisited.  Should probably just use the new hexdump(9).
+ *
+ * XXXRW: All this appears to be present just so as to printf debugging
+ * information.  Assuming that this code is known to work, we could just
+ * scrap all this.  In fact, this code isn't even used as it stands, it's
+ * here for debugging purposes only and requires modifications to
+ * at_proto.c.
+ */
+
 #define	HEXBUF_LEN	256
 
 static const char *
--- //depot/vendor/freebsd/src/sys/netatalk/at_var.h	2004/03/22 04:56:26
+++ //depot/user/rwatson/netperf/sys/netatalk/at_var.h	2004/07/20 01:38:51
@@ -60,6 +60,11 @@
 #define AFA_PHASE2	0x0004
 
 #ifdef _KERNEL
+extern struct mtx at_ifaddr_mtx;
+#define	AT_IFADDR_LIST_ASSERT()	mtx_assert(&at_ifaddr_mtx, MA_OWNED)
+#define	AT_IFADDR_LIST_LOCK()	mtx_lock(&at_ifaddr_mtx)
+#define	AT_IFADDR_LIST_UNLOCK()	mtx_unlock(&at_ifaddr_mtx)
+
 extern struct at_ifaddr	*at_ifaddr_list;
 #endif
 
--- //depot/vendor/freebsd/src/sys/netatalk/ddp_input.c	2004/08/10 03:25:35
+++ //depot/user/rwatson/netperf/sys/netatalk/ddp_input.c	2004/08/11 02:33:29
@@ -76,6 +76,11 @@
 static volatile int	ddp_firewall = 0;
 static struct ddpstat	ddpstat;
 
+/*
+ * XXXRW: If we're going to keep this cached route data, we'll need to lock it
+ * down, and change later function-local use of it to grab an extra reference
+ * after deciding it is useful.
+ */
 static struct route	forwro;
 
 static void     ddp_input(struct mbuf *, struct ifnet *, struct elaphdr *, int);
@@ -170,6 +175,7 @@
 	 * Make sure that we point to the phase1 ifaddr info 
 	 * and that it's valid for this packet.
 	 */
+	AT_IFADDR_LIST_LOCK();
 	for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 	    if ((aa->aa_ifp == ifp)
 	    && ((aa->aa_flags & AFA_PHASE2) == 0)
@@ -185,6 +191,8 @@
 	    m_freem(m);
 	    return;
 	}
+	IFAREF((struct ifaddr *)aa);
+	AT_IFADDR_LIST_UNLOCK();
     } else {
 	/*
 	 * There was no 'elh' passed on. This could still be
@@ -229,6 +237,7 @@
 	     * this node number will match (which may NOT be what we want,
 	     * but it's probably safe in 99.999% of cases.
 	     */
+	    AT_IFADDR_LIST_LOCK();
 	    for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 		if (phase == 1 && (aa->aa_flags & AFA_PHASE2)) {
 		    continue;
@@ -243,11 +252,15 @@
 		    break;
 		}
 	    }
+	    if (aa != NULL)
+		IFAREF((struct ifaddr *)aa);
+	    AT_IFADDR_LIST_UNLOCK();
 	} else {
 	    /* 
 	     * A destination network was given. We just try to find 
 	     * which ifaddr info matches it.
 	     */
+	    AT_IFADDR_LIST_LOCK();
 	    for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 		/*
 		 * This is a kludge. Accept packets that are
@@ -281,6 +294,9 @@
 		}
 		break;
 	    }
+	    if (aa != NULL)
+		IFAREF((struct ifaddr *)aa);
+	    AT_IFADDR_LIST_UNLOCK();
 	}
     }
 
@@ -293,6 +309,8 @@
     if (mlen < dlen) {
 	ddpstat.ddps_toosmall++;
 	m_freem(m);
+	if (aa != NULL)
+	    IFAFREE((struct ifaddr *)aa);
 	return;
     }
     if (mlen > dlen) {
@@ -315,6 +333,8 @@
 	 */
 	if (ddp_forward == 0) {
 	    m_freem(m);
+	    if (aa != NULL)
+		IFAFREE((struct ifaddr *)aa);
 	    return;
 	}
 	/* 
@@ -359,6 +379,8 @@
 	&& ((forwro.ro_rt == NULL)
 	  || (forwro.ro_rt->rt_ifp != ifp))) {
 	    m_freem(m);
+	    if (aa != NULL)
+		IFAFREE((struct ifaddr *)aa);
 	    return;
 	}
 
@@ -376,6 +398,8 @@
 	} else {
 	    ddpstat.ddps_forward++;
 	}
+	if (aa != NULL)
+	    IFAFREE((struct ifaddr *)aa);
 	return;
     }
 
@@ -438,6 +462,8 @@
     DDP_LIST_SUNLOCK();
     if (m != NULL)
 	m_freem(m);
+    if (aa != NULL)
+	IFAFREE((struct ifaddr *)aa);
 }
 
 #if 0
--- //depot/vendor/freebsd/src/sys/netatalk/ddp_output.c	2004/06/13 02:50:44
+++ //depot/user/rwatson/netperf/sys/netatalk/ddp_output.c	2004/07/20 01:38:51
@@ -151,6 +151,7 @@
     && (ro->ro_rt->rt_ifa)
     && (ifp = ro->ro_rt->rt_ifa->ifa_ifp)) {
 	net = ntohs(satosat(ro->ro_rt->rt_gateway)->sat_addr.s_net);
+	AT_IFADDR_LIST_LOCK();
 	for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 	    if (((net == 0) || (aa->aa_ifp == ifp)) &&
 		    net >= ntohs(aa->aa_firstnet) &&
@@ -158,6 +159,8 @@
 		break;
 	    }
 	}
+	IFAREF((struct ifaddr *)aa);
+	AT_IFADDR_LIST_UNLOCK();
     } else {
 	m_freem(m);
 #ifdef NETATALK_DEBUG
@@ -177,6 +180,8 @@
 	    ifp->if_xname);
 #endif
 	m_freem(m);
+	if (aa != NULL)
+	    IFAFREE((struct ifaddr *)aa);
 	return (ENETUNREACH);
     }
 
@@ -203,6 +208,8 @@
 	MGET(m0, M_TRYWAIT, MT_HEADER);
 	if (m0 == NULL) {
 	    m_freem(m);
+	    if (aa != NULL)
+		IFAFREE((struct ifaddr *)aa);
 	    printf("ddp_route: no buffers\n");
 	    return (ENOBUFS);
 	}
@@ -236,9 +243,13 @@
     if ((satosat(&aa->aa_addr)->sat_addr.s_net  == satosat(&ro->ro_dst)->sat_addr.s_net) &&
 	(satosat(&aa->aa_addr)->sat_addr.s_node == satosat(&ro->ro_dst)->sat_addr.s_node))
     {
+	if (aa != NULL)
+	    IFAFREE((struct ifaddr *)aa);
 	return (if_simloop(ifp, m, gate.sat_family, 0));
     }
 
+    if (aa != NULL)
+	IFAFREE((struct ifaddr *)aa);
     return ((*ifp->if_output)(ifp,
 	m, (struct sockaddr *)&gate, NULL)); /* XXX */
 }
--- //depot/vendor/freebsd/src/sys/netatalk/ddp_pcb.c	2004/07/12 18:40:50
+++ //depot/user/rwatson/netperf/sys/netatalk/ddp_pcb.c	2004/07/20 01:38:51
@@ -44,6 +44,7 @@
     struct sockaddr_at	lsat, *sat;
     struct at_ifaddr	*aa;
     struct ddpcb	*ddpp;
+    int error;
 
     /*
      * We read and write both the ddp passed in, and also ddp_ports.
@@ -51,37 +52,46 @@
     DDP_LIST_XLOCK_ASSERT();
     DDP_LOCK_ASSERT(ddp);
 
-    if (ddp->ddp_lsat.sat_port != ATADDR_ANYPORT) { /* shouldn't be bound */
-	return (EINVAL);
+    error = 0;
+    if (ddp->ddp_lsat.sat_port != ATADDR_ANYPORT) {
+	/* shouldn't be bound */
+	error = EINVAL;
+	goto out;
     }
 
     if (addr != NULL) {			/* validate passed address */
 	sat = (struct sockaddr_at *)addr;
 	if (sat->sat_family != AF_APPLETALK) {
-	    return (EAFNOSUPPORT);
+	    error = EAFNOSUPPORT;
+	    goto out;
 	}
 
 	if (sat->sat_addr.s_node != ATADDR_ANYNODE ||
 		sat->sat_addr.s_net != ATADDR_ANYNET) {
+	    AT_IFADDR_LIST_LOCK();
 	    for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 		if ((sat->sat_addr.s_net == AA_SAT(aa)->sat_addr.s_net) &&
 		 (sat->sat_addr.s_node == AA_SAT(aa)->sat_addr.s_node)) {
 		    break;
 		}
 	    }
-	    if (!aa) {
-		return (EADDRNOTAVAIL);
+	    AT_IFADDR_LIST_UNLOCK();
+	    if (aa != NULL) {
+		error = EADDRNOTAVAIL;
+		goto out;
 	    }
 	}
 
 	if (sat->sat_port != ATADDR_ANYPORT) {
 	    if (sat->sat_port < ATPORT_FIRST ||
 		    sat->sat_port >= ATPORT_LAST) {
-		return (EINVAL);
+		error = EINVAL;
+		goto out;
 	    }
 	    if (sat->sat_port < ATPORT_RESERVED &&
 		 suser(td)) {
-		return (EACCES);
+		error = EACCES;
+		goto out;
 	    }
 	}
     } else {
@@ -96,7 +106,8 @@
     if (sat->sat_addr.s_node == ATADDR_ANYNODE &&
 	    sat->sat_addr.s_net == ATADDR_ANYNET) {
 	if (at_ifaddr_list == NULL) {
-	    return (EADDRNOTAVAIL);
+	    error = EADDRNOTAVAIL;
+	    goto out;
 	}
 	sat->sat_addr = AA_SAT(at_ifaddr_list)->sat_addr;
     }
@@ -113,7 +124,8 @@
 	    }
 	}
 	if (sat->sat_port == ATPORT_LAST) {
-	    return (EADDRNOTAVAIL);
+	    error = EADDRNOTAVAIL;
+	    goto out;
 	}
 	ddp->ddp_lsat.sat_port = sat->sat_port;
 	ddp_ports[ sat->sat_port - 1 ] = ddp;
@@ -126,7 +138,8 @@
 	    }
 	}
 	if (ddpp != NULL) {
-	    return (EADDRINUSE);
+	    error = EADDRINUSE;
+	    goto out;
 	}
 	ddp->ddp_pnext = ddp_ports[ sat->sat_port - 1 ];
 	ddp_ports[ sat->sat_port - 1 ] = ddp;
@@ -135,7 +148,8 @@
 	}
     }
 
-    return (0);
+out:
+    return (error);
 }
 
 int
@@ -181,6 +195,7 @@
 	}
 	aa = NULL;
 	if ((ifp = ro->ro_rt->rt_ifp) != NULL) {
+	    AT_IFADDR_LIST_LOCK();
 	    for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 		if (aa->aa_ifp == ifp &&
 			ntohs(net) >= ntohs(aa->aa_firstnet) &&
@@ -188,6 +203,7 @@
 		    break;
 		}
 	    }
+	    AT_IFADDR_LIST_UNLOCK();
 	}
 	if (aa == NULL || (satosat(&ro->ro_dst)->sat_addr.s_net !=
 		(hintnet ? hintnet : sat->sat_addr.s_net) ||
@@ -218,11 +234,13 @@
      */
     aa = NULL;
     if (ro->ro_rt && (ifp = ro->ro_rt->rt_ifp)) {
+        AT_IFADDR_LIST_LOCK();
 	for (aa = at_ifaddr_list; aa != NULL; aa = aa->aa_next) {
 	    if (aa->aa_ifp == ifp) {
 		break;
 	    }
 	}
+        AT_IFADDR_LIST_UNLOCK();
     }
     if (aa == NULL) {
 	return (ENETUNREACH);
@@ -257,6 +275,10 @@
 	DDP_LOCK_INIT(ddp);
 	ddp->ddp_lsat.sat_port = ATADDR_ANYPORT;
 
+	/*
+	 * XXXRW: Is this unlocked assignment payer for socket and
+	 * back-pointer something that needs to be protected?
+	 */
 	ddp->ddp_socket = so;
 	so->so_pcb = (caddr_t)ddp;
 
